<?php
namespace Geral\Util;
/**
 * User: newtonsantos
 * Date: 15/07/2013
 * Time: 08:42
 * To change this template use File | Settings | File Templates.
 */
use \Geral\Logic\Picture;
class PictureProcesso extends Picture
{

    const PICTURE = 'CDPICTPROCES';


    public function __construct() {
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        parent::__construct($nrorg, $this::PICTURE);
    }

    public static function isProcessoNivelMaximo($cdprocesso, $nrorg = null, $nivel = null) {
        if(empty($nrorg)) {
            $nrorg = \Geral\Util\Ambiente::getNrorg();
        }
        if(empty($nivel)) {
            $processo = \Geral\Entities\Processo::getRepository()->findOneBy(array("cdprocesso" => $cdprocesso, "nrorg" => $nrorg));
            if(!$processo instanceof \Geral\Entities\Processo) {
                throw new \Exception("Processo não encontrado.");
            }
            $nivel = $processo->getCdnvprocesso();
        }
        return ($nivel == self::retornaNumeroMaximoDeNiveis());
    }

    public static function retornaNumeroMaximoDeNiveis() {
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        $picture = new self($nrorg);
        return $picture->getNumeroDeNiveis();
    }

    /**
     * Mascara do Item de trabalho.
     *
     * @return mixed
     */
    public static function mascaraProcesso(){
        $pic = new self();
        return $pic->getMascara();
    }


}
