import { ComponentRender, IComponentRender } from '@zeedhi/common';
import { IDictionary } from '@zeedhi/core';

export interface InterfaceCardapio extends IComponentRender {
  cardData: IDictionary;
  dates: IDictionary;
  menuContent: IDictionary;
  filterData: IDictionary;
  colorCard: IDictionary;
  preview: number;
  bindNewGridAction: (charKey: number, action: object) => void;
  moveTableSelection: (drection: string) => void;
  getCurrentSelectedRegister: () => IDictionary;
  setMenuContent: (menuContent: IDictionary) => void;
  forceUpdateInCard: () => void;
  updateComens: (comens: number, date: string) => void;
  dateLessDateOfProcess: (date: string) => boolean;
  setValueAction: (actived: boolean) => void;
}

export class Cardapio extends ComponentRender implements InterfaceCardapio {
  public cardData: IDictionary = [];
    
  public dates: IDictionary = [];
    
  public menuContent: IDictionary = [];
    
  public filterData: IDictionary = {};
    
  public colorCard: IDictionary = [];
    
  public preview = 3;

  public bindNewGridAction: (charKey: number, action: object) => void;
    
  public moveTableSelection: (direction: string) => void;
    
  public getCurrentSelectedRegister: () => IDictionary;
    
  public setMenuContent: (menuContent: IDictionary) => void;
    
  public forceUpdateInCard: () => void;
    
  public updateComens: (comens: number, date: string) => void;
    
  public dateLessDateOfProcess: (date: string) => boolean;
    
  public setValueAction: (actived: boolean) => void;
    
  constructor(props: InterfaceCardapio) {
    super(props);
    this.cardData = this.getInitValue('cardData', props.cardData, this.cardData);
    this.dates = this.getInitValue('dates', props.dates, this.dates);
    this.menuContent = this.getInitValue('menuContent', props.menuContent, this.menuContent);
    this.filterData = this.getInitValue('filterData', props.filterData, this.filterData);
    this.colorCard = this.getInitValue('colorCard', props.colorCard, this.colorCard);
    this.preview = this.getInitValue('preview', props.preview, this.preview);
    this.bindNewGridAction = this.getInitValue('bindNewGridAction', undefined, undefined);
    this.moveTableSelection = this.getInitValue('moveTableSelection', undefined, undefined);
    this.getCurrentSelectedRegister = this.getInitValue('getCurrentSelectedRegister', undefined, undefined);
    this.setMenuContent = this.getInitValue('setMenuContent', undefined, undefined);
    this.forceUpdateInCard = this.getInitValue('forceUpdateInCard', undefined, undefined);
    this.updateComens = this.getInitValue('updateComens', undefined, undefined);
    this.dateLessDateOfProcess = this.getInitValue('dateLessDateOfProcess', undefined, undefined);
    this.setValueAction = this.getInitValue('setValueAction', undefined, undefined);
  }
}
